package mvd.jester;

import java.util.Arrays;
import java.util.List;
import mvd.jester.model.DagTask;
import mvd.jester.model.SystemManager;
import mvd.jester.model.SystemManager.DagTaskBuilder;
import mvd.jester.tests.AbstractTest;
import mvd.jester.tests.JiangYi;
import mvd.jester.tests.SchmidMottok;
import mvd.jester.tests.UeterAgrawal;
import mvd.jester.tests.TypeFunction.UnknownStructure;


/**
 * Hello world!
 *
 */
public class App {
        public static void main(String[] args) {
                {
                        SystemManager<DagTaskBuilder> manager =
                                        new SystemManager<>(DagTaskBuilder.class);
                        manager.setNumberOfProcessors(8);
                        TestEnvironment te = new TestEnvironment();

                        List<AbstractTest<DagTask>> tests = te.registerTests(Arrays.asList(
                                        new SchmidMottok(new UnknownStructure(), manager), //
                                        // new Tester(new UnknownStructure(),manager),
                                        // new MelaniButtazzo(manager),,
                                        // new FonsecaNelis(manager), //
                                        // new DongLiu(manager), //
                                        new UeterAgrawal(manager), //
                                        new JiangYi(manager)//
                        ));

                        te.varyRenyiUtilization(manager, tests, 200);
                }
                {
                        SystemManager<DagTaskBuilder> manager =
                                        new SystemManager<>(DagTaskBuilder.class);
                        manager.setNumberOfProcessors(16);
                        TestEnvironment te = new TestEnvironment();

                        List<AbstractTest<DagTask>> tests = te.registerTests(Arrays.asList(
                                        new SchmidMottok(new UnknownStructure(), manager), //
                                        // new Tester(new UnknownStructure(),manager),
                                        // new MelaniButtazzo(manager),,
                                        // new FonsecaNelis(manager), //
                                        // new DongLiu(manager), //
                                        new UeterAgrawal(manager), //
                                        new JiangYi(manager)//
                        ));

                        te.varyRenyiUtilization(manager, tests, 200);
                }
                {
                        SystemManager<DagTaskBuilder> manager =
                                        new SystemManager<>(DagTaskBuilder.class);
                        manager.setNumberOfProcessors(32);
                        TestEnvironment te = new TestEnvironment();

                        List<AbstractTest<DagTask>> tests = te.registerTests(Arrays.asList(
                                        new SchmidMottok(new UnknownStructure(), manager), //
                                        // new Tester(new UnknownStructure(),manager),
                                        // new MelaniButtazzo(manager),,
                                        // new FonsecaNelis(manager), //
                                        // new DongLiu(manager), //
                                        new UeterAgrawal(manager), //
                                        new JiangYi(manager)//
                        ));

                        te.varyRenyiUtilization(manager, tests, 200);
                }
                // {
                // SystemManager<DagTaskBuilder> manager = new
                // SystemManager<>(DagTaskBuilder.class);
                // manager.setNumberOfProcessors(8);
                // TestEnvironment te = new TestEnvironment();

                // List<AbstractTest<DagTask>> tests = te.registerTests(Arrays.asList( //
                // // new SchmidMottok(new KnownStructure(), manager), //
                // new SchmidMottok(new UnknownStructure(), manager), //
                // // new Tester(new UnknownStructure(), manager), //
                // // new MelaniButtazzo(manager), //
                // new FonsecaNelis(manager), //
                // new UeterAgrawal(manager), //
                // new JiangYi(manager)));

                // te.varyNumberOfProcessors(manager, tests, 200);
                // }
                // {
                // SystemManager<DagTaskBuilder> manager = new
                // SystemManager<>(DagTaskBuilder.class);
                // manager.setNumberOfProcessors(8);
                // TestEnvironment te = new TestEnvironment();

                // List<AbstractTest<DagTask>> tests = te.registerTests(Arrays.asList( //
                // // new SchmidMottok(new KnownStructure(), manager), //
                // new SchmidMottok(new UnknownStructure(), manager), //
                // // new Tester(new UnknownStructure(), manager), //
                // // new MelaniButtazzo(manager), //
                // new FonsecaNelis(manager), //
                // new UeterAgrawal(manager), //
                // new JiangYi(manager)));

                // te.varyNumberOfTasks(manager, tests, 200);
                // }
        }
}
